import urllib.request, json,random,requests,time

# def rand_float(x):
#     sign=random.randint(1,2)
#     if (sign==1):
#         return float(random.randint(0,x*10000))/10000
#     else:
#         return -float(random.randint(0,x*10000))/10000
    

def iss_location():
    url="http://api.open-notify.org/iss-now.json"
    response=urllib.request.urlopen(url)
    data=json.loads(response.read().decode())
    x=data["iss_position"]
    print("Current Location of ISS:")
    print("Latitude : "+x['latitude'])
    print("Longitude : "+x['longitude'])
    
def pass_time():
    #lati=rand_float(90)
    #long=rand_float(180)
    print("Enter Details to know when ISS will pass over a location:")
    lati=input("Latitude : ")
    long=input("Longitude : ")    
    #r=requests.get("http://api.open-notify.org/iss-pass.json")
    payload={'lat':lati,'lon':long}
    r1=requests.get('http://api.open-notify.org/iss-pass.json',params=payload)
    url1=r1.url
    response=urllib.request.urlopen(url1)
    data1=json.loads(response.read().decode())
    #print(data1)
    data2=(data1['response'])[0]
    dur=int(data2['duration'])
    dt=time.strftime("%d/%m/%y %H:%M", time.localtime(int(data2['risetime'])))
    dt2=dt.split()
    
    
    #print("Latitude:"+str(lati))
    #print("Longitude:"+str(long))
    print("Date : "+str(dt2[0]))
    print("Time : "+str(dt2[1]))
    print("For : "+str(int(dur/60))+" minutes and "+str((dur%60))+" seconds")
    

def people_info():
    url="http://api.open-notify.org/astros.json"
    response=urllib.request.urlopen(url)
    data=json.loads(response.read().decode())
    x=data["people"]                   #people in space
    y=(data["number"])
    print("People currently in space:"+str(y))
    count=0
    for person in x:
        print(str(count+1)+". "+(x[count])["name"])
        count=count+1
        
iss_location()
pass_time()
people_info()
